tbb::interface6::internal::concrete_filter< void, U, Body > Class Template Reference

`#include <pipeline.h>`

Inheritance diagram for tbb::interface6::internal::concrete_filter< void, U, Body >:
Collaboration diagram for tbb::interface6::internal::concrete_filter< void, U, Body >:

## Public Member Functions

| concrete_filter (tbb::filter::mode filter_mode, const Body &body)
Public Member Functions inherited from tbb::filter
bool | is_serial () const
| True if filter is serial. More...
bool | is_ordered () const
| True if filter must receive stream in order. More...
bool | is_bound () const
| True if filter is thread-bound. More...
bool | object_may_be_null ()
| true if an input filter can emit null More...
virtual __TBB_EXPORTED_METHOD | ~filter ()
| Destroy filter. More...
virtual void | finalize (void *)
| Destroys item if pipeline was cancelled. More...

## Private Types

typedef token_helper< U, use_allocator< U >::value > | u_helper
typedef u_helper::pointer | u_pointer

## Private Member Functions

void * | operator() (void *) __TBB_override
| Operate on an item from the input stream, and return item for output stream. More...

## Private Attributes

const Body & | my_body

## Additional Inherited Members

Public Types inherited from tbb::filter
enum | mode { parallel = current_version | filter_is_out_of_order , serial_in_order = current_version | filter_is_serial , serial_out_of_order = current_version | filter_is_serial | filter_is_out_of_order , serial = serial_in_order }
Protected Member Functions inherited from tbb::filter
| filter (bool is_serial_)
| filter (mode filter_mode)
void __TBB_EXPORTED_METHOD | set_end_of_input ()
Static Protected Attributes inherited from tbb::filter
static const unsigned char | filter_is_serial = 0x1
| The lowest bit 0 is for parallel vs. serial. More...
static const unsigned char | filter_is_out_of_order = 0x1<<4
| 4th bit distinguishes ordered vs unordered filters. More...
static const unsigned char | filter_is_bound = 0x1<<5
| 5th bit distinguishes thread-bound and regular filters. More...
static const unsigned char | filter_may_emit_null = 0x1<<6
| 6th bit marks input filters emitting small objects More...
static const unsigned char | exact_exception_propagation
| 7th bit defines exception propagation mode expected by the application. More...
static const unsigned char | current_version = __TBB_PIPELINE_VERSION(5)
static const unsigned char | version_mask = 0x7<<1

## Detailed Description

### template<typename U, typename Body>
class tbb::interface6::internal::concrete_filter< void, U, Body >

Definition at line 454 of file pipeline.h.

## Member Typedef Documentation

## u_helper

template<typename U , typename Body >

typedef token_helper<U, use_allocator<U>::value> tbb::interface6::internal::concrete_filter< void, U, Body >::u_helper

private

Definition at line 456 of file pipeline.h.

## u_pointer

template<typename U , typename Body >

typedef u_helper::pointer tbb::interface6::internal::concrete_filter< void, U, Body >::u_pointer

private

Definition at line 457 of file pipeline.h.

## Constructor & Destructor Documentation

## concrete_filter()

template<typename U , typename Body >

tbb::interface6::internal::concrete_filter< void, U, Body >::concrete_filter | ( | tbb::filter::mode | filter_mode,
|  | const Body & | body
| ) |  |

inline

Definition at line 471 of file pipeline.h.

:
filter(static_cast<tbb::filter::mode>(filter_mode | filter_may_emit_null)),
my_body(body)
{}
tbb::filter::filter_may_emit_null
static const unsigned char filter_may_emit_null
6th bit marks input filters emitting small objects
Definition: pipeline.h:81
tbb::filter::mode
mode
Definition: pipeline.h:94
tbb::filter::filter
filter(bool is_serial_)
Definition: pipeline.h:105
tbb::interface6::internal::concrete_filter< void, U, Body >::my_body
const Body & my_body
Definition: pipeline.h:455

## Member Function Documentation

## operator()()

template<typename U , typename Body >

void* tbb::interface6::internal::concrete_filter< void, U, Body >::operator() | ( | void * | item | ) |

inline private virtual

Operate on an item from the input stream, and return item for output stream.

Returns NULL if filter is a sink.

Implements tbb::filter.

Definition at line 459 of file pipeline.h.

{
flow_control control;
u_pointer output_u = u_helper::create_token(my_body(control));
if(control.is_pipeline_stopped) {
u_helper::destroy_token(output_u);
set_end_of_input();
return NULL;
}
return u_helper::cast_to_void_ptr(output_u);
}
tbb::filter::set_end_of_input
void __TBB_EXPORTED_METHOD set_end_of_input()
Definition: pipeline.cpp:708
tbb::interface6::internal::concrete_filter< void, U, Body >::u_pointer
u_helper::pointer u_pointer
Definition: pipeline.h:457

References tbb::interface6::flow_control::is_pipeline_stopped, tbb::interface6::internal::concrete_filter< T, U, Body >::my_body, and tbb::filter::set_end_of_input().

Here is the call graph for this function:

## Member Data Documentation

## my_body

template<typename U , typename Body >

const Body& tbb::interface6::internal::concrete_filter< void, U, Body >::my_body

private

Definition at line 455 of file pipeline.h.

The documentation for this class was generated from the following file:

- pipeline.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.